using WingInterfaceLibrary.DTO.Management;
using WingInterfaceLibrary.DTO.UserFeature;
using WingInterfaceLibrary.Request.Management;
using WingInterfaceLibrary.DTO.Organization;
using WingInterfaceLibrary.DTO.User;
using WingInterfaceLibrary.DTO.Role;
using WingInterfaceLibrary.DTO.Device;
using AutoMapper;
using WingInterfaceLibrary.DTO.Dictionary;
using WingInterfaceLibrary.DTO.BaseFeature;
using WingInterfaceLibrary.DTO.AdminFeature;
using WingInterfaceLibrary.Interface;
using WingInterfaceLibrary.DTO.Consultation;
using WingInterfaceLibrary.DTO.Patient;
using WingServerCommon.Interfaces.Cache;

namespace WingLiveConsultationService
{
    /// <summary>
    /// Auto mapper profile
    /// </summary>
    public class AutoMapperProfile : Profile
    {
        public AutoMapperProfile()
        {

            CreateMap<UserDTO, OrganizationExpertDTO>().ReverseMap();
            CreateMap<UserDTO, ConsultationAssistantDTO>().ReverseMap();
            CreateMap<UserDTO, ConsultationAssistantDoctorDTO>().ReverseMap();
            CreateMap<UserDTO, UserPasswordDTO>().ReverseMap();
            CreateMap<UserDTO, UserExtendDTO>().ReverseMap();
            CreateMap<PatientInfoDTO, ClientPatientInfoBaseDTO>().ReverseMap();
            CreateMap<DeviceInfoDTO, DeviceExtendInfoDTO>().ReverseMap();
            CreateMap<DeviceInfoDTO, EmergencyDeviceInfoDTO>().ReverseMap();
            CreateMap<TokenDTO, Token>().ReverseMap();
        }
    }
}
