﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using WingServerCommon.Config;
using WingServerCommon.Log;
using ComponentAce.Compression.Libs.zlib;
using WingInterfaceLibrary.DTO.LiveRoom;
using System.Numerics;

namespace WingLiveConsultationService.Utilities
{
    public class ShortGuid
    {
        // I choose the base 36 because it generates little bit longer than 62.  
        // base36 vs. base62 vs. guid  
        // 25-26 vs. 22-23 vs. 36  
        //http://blog.csdn.net/hankersyan/article/details/51280361
        private static readonly char[] Base36 = {
                '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
                'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
                'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
                'u', 'v', 'w', 'x', 'y', 'z'
            };

        private static string ToBase36String(byte[] toConvert, bool bigEndian = false)
        {
            if (bigEndian) Array.Reverse(toConvert); // !BitConverter.IsLittleEndian might be an alternative  
            var dividend = new BigInteger(toConvert);
            var builder = new StringBuilder();
            while (dividend != 0)
            {
                dividend = BigInteger.DivRem(dividend, 36, out var remainder);
                builder.Insert(0, Base36[Math.Abs((int)remainder)]);
            }
            return builder.ToString();
        }

        /// <summary>
        /// Generate a 26 byte guid.
        /// </summary>
        /// <returns>26 byte guid.</returns>
        public static string NewGuid()
        {
            return $"v{ToBase36String(Guid.NewGuid().ToByteArray())}";
        }
    }
}
